#include "desc.hh"

#ifdef IN_OBJECT
/*
   Object cache descriptors
 */


void *Descriptor::address(int offset)
{
	return _object + _offset + offset;
}

void Descriptor::adjust(int adjustment)
{
	_offset += adjustment;
}

Descriptor::Descriptor(Descriptor &base, int offset)
{
	_object = base._object;
	_offset = base._offset + offset;
}

Descriptor::Descriptor(void *base)
{
	_object = base;
	_offset = 0;
}

void Descriptor::fetch(Descriptor &it, int offset, int which)
{
	void	*offset_loc;

	offset_loc = _object + _offset + offset;
	offset_loc += sizeof(void *) * which;

	it.set(_object);
	it.adjust(*(unsigned *) offset_loc);
}

void	Descriptor::set(void *base)
{
	_object = base;
	_offset = 0;
}

void	Descriptor::set(Descriptor &it, int offset)
{
	_object = it._object;
	_offset = it._offset;
}
#endif /* IN_OBJECT */

#ifdef IN_CACHE

void *Descriptor::address(int offset)
{
	return _address + offset;
}

void Descriptor::adjust(int adjustment)
{
	_address += adjustment;
}

Descriptor::Descriptor(Descriptor &base, int offset)
{
	_address = base.address(offset);
}

Descriptor::Descriptor(void *base)
{
	_address = base;
}

void Descriptor::fetch(Descriptor &it, int offset, int which)
{
	it._address = *(void **)(_address + offset + which*sizeof(void *));
}

void	Descriptor::set(void *base)
{
	_address = base;
}

void	Descriptor::set(Descriptor &it, int offset)
{
	_address = it.address(offset);
}
#endif /* IN_CACHE */
