BEGIN { 
	number = 0;
	array_name = "enum_names";
}

/^#/ || /^[ 	]*$/ {
	next;
}

/^NAME/ {
	array_name = $2;
	next;
}
	
NF == 1 {
	name[number] = $1;
	enum[number++] = $1;
	next;
}

NF == 2 {
	name[number] = $2;
	enum[number++] = $1;
	next;
}

{
	printf("LEFTOVER NF=%d, '%s'\n", NF, $0);
}

END {
	printf("#ifdef __cplusplus\nextern \"C\" {\n#endif\n");
	printf("char *%s[] =  {\n", array_name);
	for (i = 0; i < number; i++)
		printf("\t\"%s\",\n", name[i]);
	printf("}; /* %s */\n", array_name);
	printf("int num_%s = %d;\n", array_name, number );
	printf("#ifdef __cplusplus\n}\n#endif\n");
}
	
