#include <stdlib.h>
#include <ostream.h>
#include <stdio.h>
#include <stdiostream.h>

#include "tree.hh"
#include "ql_if.h"

#include "aqua.hh"

extern "C" {
/*
   C++ to C frontend functions for the parse
 */  

Ql_tree_node *
ql_tr_build_node_no_son(int type, char *id)
{
	return new Ql_tree_node((NodeType) type, id);
}

Ql_tree_node *
ql_tr_build_node_one_son(int type, Ql_tree_node *one)
{
	return new Ql_tree_node((NodeType) type, 1, one);
}

Ql_tree_node *
ql_tr_build_node_two_sons(int type, Ql_tree_node *one, Ql_tree_node *two)
{
	return new Ql_tree_node((NodeType) type, 2, one, two);
}

Ql_tree_node *
ql_tr_build_node_three_sons(int type,
			    Ql_tree_node *one,
			    Ql_tree_node *two,
			    Ql_tree_node *three)
{
	return new Ql_tree_node((NodeType) type, 3, one, two, three);
}

Ql_tree_node *
ql_tr_build_node_four_sons(int type,
			    Ql_tree_node *one,
			    Ql_tree_node *two,
			   Ql_tree_node *three,
			   Ql_tree_node *four)
{
	return new Ql_tree_node((NodeType) type, 4, one, two, three, four);
}

Ql_tree_node *
ql_tr_add_left_son(Ql_tree_node *me, Ql_tree_node*son)
{
	return me->addLeft(son);
}

} /* extern "C" */



#if 0
void ql_tr_free(Ql_tree_node *root)
{
	delete root;
}

void ql_tr_print(FILE *fp, Ql_tree_node *node)
{
//	stdiobuf glue(fp);
//	ostream s(&glue);
	cout << node;
}

char *
aq_convert(Ql_tree_node *root)
{
	aqua_t *at;

	at = root->aqua_convert();
	return (char *)at;
}

char *
aq_typecheck(aqua_t *root)
{
	Type	*result;
	result = root->typecheck();
	cout << "Results in ... " << *result << '\n';
	return (char *)result;
}

void aq_free(aqua_t *root)
{
	// delete root;
}

void aq_print(FILE *fp, aqua_t *node)
{
//	stdiobuf glue(fp);
//	ostream s(&glue);
	cout << *node << '\n';
}
#endif


/* } /* extern C */
