
#include <stdlib.h>
#include <stdio.h>
#include <ostream.h>

#include "symbol.hh"
#include "types.hh"
#include "typedb.hh"
#include "tree.hh"

#include "desc.hh"

#include "runtime.hh"

extern "C" {
	extern void bcopy(void *, void *, int );
}

/*
   Return the appropriate accessor
   for the collection.

   As all collections in shore use the same format,
   only one is needed.  The flexibility remains, however.
   (all though it could be removed for increased efficiency)
 */  
CollectionAccessor *CollectionType::accessor(Descriptor &d, int offset)
{
	return new TheAccessor(d, offset, *CollectionType::_of);
}

void	PrimitiveType::extract(Descriptor &d, int offset, void *where)
{
	Descriptor the_string;

	switch (_primitive) {
	case pt_string:
		d.fetch(the_string, offset);
		*(char **)where = (char *)the_string.address();
		break;
	default:
		bcopy(d.address(offset), where, inline_size());
		break;
	}
}

