
/*
   The way this is structured, this should be
   determined by the Descriptor
 */  
   

#ifdef notyet
typedef union {
	int	offset;
	void	*pointer;
} PTR;
#else
#ifdef IN_CACHE
typedef	void	*PTR;
#endif
#ifdef IN_OBJECT
typedef	int	PTR;
#endif
#endif



typedef struct {
	PTR	collection;
	int	count;
} InlineCollection;

typedef struct {
	int	oid;
} InlineObject;

typedef struct {
	PTR	string;
} InlineString;


class TheAccessor : public CollectionAccessor {
private:
	Type	&_of;
	int	_at;		// for iterating 
	int	_count;
	Descriptor	_indirect;

public:
	TheAccessor(Descriptor &d, int offset, Type &of) : _of(of) {
		InlineCollection *ic = (InlineCollection *) d.address(offset);
		_count = ic->count;
		/* XXX the pointer is the first thing in the I.C. */
		d.fetch(_indirect, offset);
	}

	int	count() { return _count; }
	Type	&of() { return _of; }

	bool	at(int i, Descriptor &d) {
		if (i < 0 || i >= _count)
			return false;
		/* items in-line */
		d.set(_indirect);
		d.adjust(i * _of.inline_size());
		return true;
	}

	bool	more() { return _at < _count; }
	bool	next(Descriptor &d) { return at(_at++, d); }
};
