#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include "getopt.h"

#include "ostream.h"
#include "symbol.hh"
#include "types.hh"
#include "typedb.hh"
#include "oql_context.hh"

char *_progname;

#include "db.hh"


main(int argc, char **argv)
{
	int	errors = 0;
	int	hoofer = 1;
	int	c;
	oqlContext	context;
	

	while ((c = getopt(argc, argv, "pcPCtTbBvV")) != EOF) {
		switch (c) {
		case 'b':
			hoofer=1;
			break;
		case 'B':
			hoofer=0;
			break;
		default:
			errors++;
			break;
		}
	}
	if (errors) {
		fprintf(stderr,
		"usage: %s  [-b (hoofer db)] OR [-t (travel db)]\n",
			_progname);
		exit(1);
	}

	init_atomic(context.db);
	if (hoofer)
		init_hoofer_db(context.db);
	else
		init_travel_db(context.db);


	Type *sailboat = context.db.types.force_lookup("Sailboat");

	sailboat->save();

	exit(0);
}




save_type(Type *type)
{
	type->save();
}
