#ifndef _TYPEDB_H_
#define _TYPEDB_H_

#include "symbol.hh"
#include "types.hh"

class GenericDB : public SymbolTable {
public:
	GenericDB(char *whatfor) : SymbolTable(whatfor) { }
	void add(Type *t);		/* Add a named type */
	void add(char *name, Type *t); 	/* Add a name for a type */
	Type *lookup(char *name);
	Type *force_lookup(char *name);
};

class TypeDB : public GenericDB {
public:
	TypeDB(char *name) : GenericDB(name) {} 
	/* commit new types to the store */
	void	commit();
	void	save();
};

class ExtentDB : public GenericDB {
public:
	ExtentDB(char *name) : GenericDB(name) {} 
};



#endif /* _TYPEDB_H_ */ 
